-- Autoimprove
-- Author: Z
-- DateCreated: 10/24/2015 10:48:23 PM
--------------------------------------------------------------
--print("MDM loaded");
local resImpr = {
	[GameInfoTypes.RESOURCE_WHEAT] = GameInfoTypes.IMPROVEMENT_FARM,

	[GameInfoTypes.RESOURCE_COW] = GameInfoTypes.IMPROVEMENT_PASTURE,
	[GameInfoTypes.RESOURCE_SHEEP] = GameInfoTypes.IMPROVEMENT_PASTURE,
	[GameInfoTypes.RESOURCE_HORSE] = GameInfoTypes.IMPROVEMENT_PASTURE,

	[GameInfoTypes.RESOURCE_DEER] = GameInfoTypes.IMPROVEMENT_CAMP,
	[GameInfoTypes.RESOURCE_FUR] = GameInfoTypes.IMPROVEMENT_CAMP,
	[GameInfoTypes.RESOURCE_IVORY] = GameInfoTypes.IMPROVEMENT_CAMP,
	[GameInfoTypes.RESOURCE_TRUFFLES] = GameInfoTypes.IMPROVEMENT_CAMP,
	[GameInfoTypes.RESOURCE_BISON] = GameInfoTypes.IMPROVEMENT_CAMP,

	[GameInfoTypes.RESOURCE_GOLD] = GameInfoTypes.IMPROVEMENT_MINE,
	[GameInfoTypes.RESOURCE_SILVER] = GameInfoTypes.IMPROVEMENT_MINE,
	[GameInfoTypes.RESOURCE_GEMS] = GameInfoTypes.IMPROVEMENT_MINE,
	[GameInfoTypes.RESOURCE_SALT] = GameInfoTypes.IMPROVEMENT_MINE,
	[GameInfoTypes.RESOURCE_COPPER] = GameInfoTypes.IMPROVEMENT_MINE,
	[GameInfoTypes.RESOURCE_COAL] = GameInfoTypes.IMPROVEMENT_MINE,
	[GameInfoTypes.RESOURCE_IRON] = GameInfoTypes.IMPROVEMENT_MINE,

	[GameInfoTypes.RESOURCE_OIL] = GameInfoTypes.IMPROVEMENT_WELL,
	};

function CheckSaloon(iPlayerID, iCityID)
	--print("event fired");
	local player = Players[iPlayerID];
	if player == nil then
		return;
	end
	local city = player:GetCityByID(iCityID);
	if city == nil then
		return;
	end
	local iteam = player:GetTeam();
	if city:IsHasBuilding(GameInfoTypes.BUILDING_SALOON) then
		--print("we have saloon");
		for i = 0, city:GetNumCityPlots() do
			local plot = city:GetCityIndexPlot(i);
			if plot ~= nil and plot:GetOwner() == iPlayerID and not plot:IsWater() and plot:GetImprovementType() == -1 then
				--print("conditions are met");
				local ires = plot:GetResourceType(iteam);				
				local impr = resImpr[ires];
				if impr ~= nil then
					plot:SetImprovementType(impr);
				end
			end	-- /plot valid
		end	-- /loop plots
	end
end
Events.SpecificCityInfoDirty.Add( CheckSaloon );